apiVersion: v1
kind: Service
metadata:
  name: {{ app.name }}
  namespace: {{ kubernetes_namespace }}
  labels:
    app: {{ app.name }}
spec:
  ports:
    - port: {{ app.port }}
      targetPort: {{ app.port }}
      protocol: TCP
      name: http
  topologyKeys:
    - "kubernetes.io/hostname"
    - "*"
  selector:
    app: {{ app.name }}
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ app.name }}
  namespace: {{ kubernetes_namespace }}
  labels:
    app: {{ app.name }}
spec:
  selector:
    matchLabels:
      app: {{ app.name }}
  replicas: {{ app.pod_replicas }}
  template:
    metadata:
      labels:
        app: {{ app.name }}
      annotations:
#        date: "{{ ansible_date_time.epoch|string }}"
    spec:
      affinity:
        nodeAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
            - weight: 100
              preference:
                matchExpressions:
                  - key: kubernetes.io/arch
                    operator: In
                    values:
                      - amd64
      hostNetwork: true
      imagePullSecrets:
        - name: {{ token }}
      containers:
        - name: {{ app.name }}
          imagePullPolicy: Always
          image: {{ app.image }}
          livenessProbe:
            httpGet:
              path: {{ app.healthcheck }}
              port: {{ app.port }}
            initialDelaySeconds: 60
            periodSeconds: 30
            failureThreshold: 3
          readinessProbe:
            httpGet:
              path: {{ app.healthcheck }}
              port: {{ app.port }}
            initialDelaySeconds: 60
            periodSeconds: 30
          resources:
            limits:
              cpu: {{ app.resources_cpu_limits }}
              memory: {{ app.resources_memory_limits }}
            requests:
              cpu: {{ app.resources_cpu_requests }}
              memory: {{ app.resources_memory_requests }}
          volumeMounts:
            - name: config-data
              mountPath: /config
            - name: test-data
              mountPath: /tmp
      initContainers:
        - name: init
          image: {{ app.image }}
          command: ['sh', '-c']
          args:
            - 'cat /etc/resolv.conf | sed -r "s/^(search.*|options.*)/#\1/" > /tmp/resolv && cat /tmp/resolv > /etc/resolv.conf;'
          volumeMounts:
            - name: test-data
              mountPath: /tmp
      volumes:
        - name: test-data
          emptyDir: {}
        - name: config-data
          persistentVolumeClaim:
            claimName: {{ app.name }}-config